import java.awt.image.BufferedImage;
/**/
public class Card {
  /**/
  private int suit, value;
  private boolean isUp;
  private BufferedImage cardImageUp, cardImageDown;
  private String name;
  /**/
  public Card ( String name, CardResources cr ) {
    /**/
    this.name=name;
    init(cr);
  }
  /**/
  public String getName () {
    return name;
  }
  /**/
  public boolean equals ( Card o ) {
    if ( o.getName().equals(name) ) return true;
    else                            return false;
  }
  /*
   *   suit = 0 1 2 3
   *          C D H S
   */
  public int getSuit () {
    return suit;
  }
  /*
   *          A           J  Q  K
   *  value = 1 2 ... 10 11 12 13
   */
  public int getValue () {
    return value;
  }
  /**/
  public boolean isUp () {
    return isUp;
  }
  /**/
  public void flip () {
    if ( isUp ) isUp=false;
    else        isUp=true;
  }
  /**/
  public BufferedImage getImage () {
    if ( isUp ) return cardImageUp;
    else        return cardImageDown;
  }
  /**/
  public boolean isBlack () {
    if ( ( suit == 0 ) || ( suit == 3 ) ) return true;
    else                                  return false;
  }
  /**/
  public boolean isRed () {
    if ( ( suit == 1 ) || ( suit == 2 ) ) return true;
    else                                  return false;
  }
  /**/
  public static boolean areDifferentColors ( Card c1, Card c2 ) {
    if      ( ( c1.isRed() ) && ( c2.isBlack() ) ) return true;
    else if ( ( c1.isBlack() ) && ( c2.isRed() ) ) return true;
    else                                           return false;
  }
  /**/
  private void init ( CardResources cr ) {
    /**/
    char suitChar;
    String cardS;
    /**/
    suitChar=name.charAt(0);
    suit=-1;
    if      ( suitChar == 'c' ) suit=0;
    else if ( suitChar == 'd' ) suit=1;
    else if ( suitChar == 'h' ) suit=2;
    else if ( suitChar == 's' ) suit=3;
    /**/
    cardS=name.substring(1);
    if      ( cardS.equals("a") ) value= 1;
    else if ( cardS.equals("j") ) value=11;
    else if ( cardS.equals("q") ) value=12;
    else if ( cardS.equals("k") ) value=13;
    else                          value=Integer.parseInt(cardS);
    /**/
    isUp=true;
    /**/
    cardImageUp=cr.getImage(name);
    cardImageDown=cr.getImage("back");
  }
}
