import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;
import javax.imageio.ImageIO;
/**/
public class CardResources {
  /**/
  private BufferedImage [] cardImages, partialCardImages;
  private BufferedImage [] cardImagesLight, partialCardImagesLight;
  private String [] cardNames;
  /**/
  public CardResources () {
    /**/
    initCardNames();
    initCardImages();
  }
  /**/
  public String [] getCardNames () {
    return cardNames;
  }
  /**/
  public BufferedImage getImage ( String cardName ) {
    return cardImages[indexOf(cardName)];
  }
  /**/
  public BufferedImage getPartialImage ( String cardName ) {
    return partialCardImages[indexOf(cardName)];
  }
  /**/
  public BufferedImage getLightImage ( String cardName ) {
    return cardImagesLight[indexOf(cardName)];
  }
  /**/
  public BufferedImage getPartialLightImage ( String cardName ) {
    return partialCardImagesLight[indexOf(cardName)];
  }
  /**/
  private void initCardNames () {
    /**/
    cardNames = new String [] {
      "c2" , "c3" , "c4" , "c5" , "c6" , "c7" , "c8" , "c9" , "c10" , "cj" , "cq" , "ck" , "ca" ,
      "d2" , "d3" , "d4" , "d5" , "d6" , "d7" , "d8" , "d9" , "d10" , "dj" , "dq" , "dk" , "da" ,
      "h2" , "h3" , "h4" , "h5" , "h6" , "h7" , "h8" , "h9" , "h10" , "hj" , "hq" , "hk" , "ha" ,
      "s2" , "s3" , "s4" , "s5" , "s6" , "s7" , "s8" , "s9" , "s10" , "sj" , "sq" , "sk" , "sa" ,
      "back" , "empty"
    };
    /**/
    return;
  }
  /**/
  private int indexOf ( String cardName ) {
    /**/
    int rv;
    /**/
    rv=-1;
    for ( int i=0; i<cardNames.length; ++i ) {
      if ( cardName.equals(cardNames[i]) ) {
        rv=i;
        break;
      }
    }
    /**/
    return rv;
  }
  /**/
  private void initCardImages () {
    /**/
    int len;
    URL url;
    /**/
    len=cardNames.length;
    /**/
    cardImages=new BufferedImage [len];
    for ( int i=0; i<len; ++i ) {
      url=CardResources.class.getResource( "card_images/" + cardNames[i] + ".gif" );
      cardImages[i]=null;
      try { cardImages[i]=ImageIO.read(url); }
      catch ( IOException ioe ) { }
    }
    /**/
    partialCardImages=new BufferedImage [len];
    for ( int i=0; i<len; ++i ) {
      url=CardResources.class.getResource( "card_images_partial/" + cardNames[i] + "p.gif" );
      partialCardImages[i]=null;
      try { partialCardImages[i]=ImageIO.read(url); }
      catch ( IOException ioe ) { }
    }
    /**/
    cardImagesLight=new BufferedImage [len];
    for ( int i=0; i<len; ++i ) {
      url=CardResources.class.getResource( "card_images_light/" + cardNames[i] + "s.gif" );
      cardImagesLight[i]=null;
      try { cardImagesLight[i]=ImageIO.read(url); }
      catch ( IOException ioe ) { }
    }
    /**/
    partialCardImagesLight=new BufferedImage [len];
    for ( int i=0; i<len; ++i ) {
      url=CardResources.class.getResource( "card_images_partial_light/" + cardNames[i] + "ps.gif" );
      partialCardImagesLight[i]=null;
      try { partialCardImagesLight[i]=ImageIO.read(url); }
      catch ( IOException ioe ) { }
    }
    /**/
    return;
  }
}
