import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Robot;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import javax.swing.JPanel;
/**/
public class CardStackPanel extends JPanel implements MouseListener {
  /**/
  private int selectedIndex;
  private MainWindow mw;
  private JPanel parent;
  private BufferedImage [] bia;
  private Robot robot;
  /**/
  public CardStackPanel ( MainWindow mw, JPanel parent, BufferedImage [] bia ) {
    /**/
    super();
    setFocusable(false);
    /**/
    this.mw=mw;
    this.parent=parent;
    this.bia=bia;
    selectedIndex=-1;
    /**/
    setPreferredSize( new Dimension(37,338) );
    /**/
    addMouseListener(this);
    /**/
    robot=mw.getRobot();
  }
  /**/
  public BufferedImage [] getImages () {
    return bia;
  }
  /**/
  public void setImages ( BufferedImage [] x ) {
    bia=x;
    parent.repaint();
  }
  /**/
  public int getSelectedIndex() {
    return selectedIndex;
  }
  /**/
  public void setSelectedIndex ( int index ) {
    selectedIndex=index;
  }
  /**/
  public void paintComponent ( Graphics g ) {
    /**/
    int len, h;
    /**/
    len=bia.length;
    h=-17;
    for ( int i=0; i<len; ++i ) {
      h += 17;
      g.drawImage(bia[i],0,h,this);
    }
    /**/
    return;
  }
  /**/
  public void mouseClicked ( MouseEvent me ) {
    /**/
    int y, index;
    CardStackPanel [] cspa;
    ColumnDecksPanel cdp;
    InfoDialog mid;
    MoveProcessor mp;
    String rawSource, source;
    String [] error;
    /**/
    mp=mw.getMoveProcessor();
    /**/
    if ( mp.getNumClicks() == 1 ) {
      robot.keyPress(KeyEvent.VK_ENTER);
      robot.keyRelease(KeyEvent.VK_ENTER);
    }
    /**/
    mp.incrementNumClicks();
    y=me.getY();
    selectedIndex=getIndexOfClickedCard(y);
    /**/
    rawSource=parent.toString();
    index=rawSource.indexOf('[');
    source=rawSource.substring(0,index);
    /**/
    cdp=mw.getColumnDecksPanel();
    cspa=cdp.getCardStackPanels();
    for ( int i=0; i<7; ++i ) {
      index=cspa[i].getSelectedIndex();
      if ( index != -1 ) {
        cspa[i].setSelectedIndex(-1);
        source += ( " " + i + index );
        break;
      }
    }
    /*
     *  from click
     */
    if ( !mp.fromIsSet() ) {
      mp.setFrom(true);
      mp.setFromSource(source);
    }
    /*
     *  to click
     */
    else {
      mp.setFrom(false);
      mp.setToSource(source);
    }
    setCardStackImages(source);
    /**/
    return;
  }
  /**/
  public void mouseEntered ( MouseEvent me ) {
    return;
  }
  /**/
  public void mouseExited ( MouseEvent me ) {
    return;
  }
  /**/
  public void mousePressed ( MouseEvent me ) {
    return;
  }
  /**/
  public void mouseReleased ( MouseEvent me ) {
    return;
  }
  /**/
  private int getIndexOfClickedCard ( int y ) {
    /**/
    int len, rv, cut;
    /**/
    len=bia.length;
    rv=-1;
    cut=0;
    for ( int i=0; i<len; ++i ) {
      cut += 17;
      if ( i == len-1 ) cut += 32;
      if ( y < cut ) {
        rv=i;
        break;
      }
    }
    /**/
    return rv;
  }
  /**/
  private void setCardStackImages ( String s ) {
    /**/
    int sp, si, len;
    BufferedImage [] oldImages, newImages;
    Card c;
    CardResources cr;
    CardRow cRow;
    CardRow [] cra;
    CardRows crs;
    CardStackPanel csp;
    CardStackPanel [] cspa;
    ColumnDecksPanel cdp;
    String name;
    String [] tokens;
    /**/
    cr=mw.getCardResources();
    cdp=mw.getColumnDecksPanel();
    cspa=cdp.getCardStackPanels();
    crs=mw.getCardRows();
    cra=crs.getCardRows();
    /**/
    tokens=s.split(" ");
    sp=Integer.parseInt(tokens[1].substring(0,1));
    si=Integer.parseInt(tokens[1].substring(1));
    cRow=cra[sp];
    csp=cspa[sp];
    len=cRow.size();
    oldImages=csp.getImages();
    /**/
    if ( len == 0 ) {
      newImages=new BufferedImage [1];
      newImages[0]=cr.getLightImage("empty");
    }
    else {
      newImages=new BufferedImage [len];
      /**/
      for ( int i=0; i<si; ++i ) newImages[i]=oldImages[i];
      for ( int i=si; i<len; ++i ) {
        c=cRow.getCardFromIndex(i);
        name=c.getName();
        if ( i != len-1 ) {
          if ( !c.isUp() ) newImages[i]=cr.getPartialLightImage("back");
          else             newImages[i]=cr.getPartialLightImage(name);
        }
        else {
          newImages[i]=cr.getLightImage(name);
        }
      }
    }
    csp.setImages(newImages);
    /**/
    return;
  }
}
