import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Robot;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
/**/
public class ClickableCard extends JPanel implements MouseListener {
  /**/
  private boolean isSelected;
  private BufferedImage bi;
  private JPanel parent;
  private MainWindow mw;
  private Robot robot;
  /**/
  public ClickableCard ( MainWindow mw, JPanel parent, BufferedImage bi ) {
    /**/
    super();
    setFocusable(false);
    /**/
    int w, h;
    /**/
    isSelected=false;
    this.mw=mw;
    this.parent=parent;
    this.bi=bi;
    /**/
    w=bi.getWidth();
    h=bi.getHeight();
    setPreferredSize( new Dimension(w,h) );
    /**/
    addMouseListener(this);
    /**/
    robot=mw.getRobot();
  }
  /**/
  public void setSelected ( boolean b ) {
    isSelected=b;
  }
  /**/
  public boolean isSelected () {
    return isSelected;
  }
  /**/
  public void setImage ( BufferedImage b ) {
    bi=b;
    repaint();
  }
  /**/
  public void paintComponent ( Graphics g ) {
    g.drawImage(bi,0,0,this);
  }
  /**/
  public void mouseClicked ( MouseEvent me ) {
    /**/
    int index;
    ClickableCard up, down;
    ClickableCard [] cca;
    DestinationDeckPanel ddp;
    InfoDialog mid;
    MoveProcessor mp;
    PlayDeck pd;
    PlayDeckPanel pdp;
    String rawSource, source;
    String [] error;
    /**/
    mp=mw.getMoveProcessor();
    /**/
    if ( mp.getNumClicks() == 1 ) {
      robot.keyPress(KeyEvent.VK_ENTER);
      robot.keyRelease(KeyEvent.VK_ENTER);
    }
    mp.incrementNumClicks();
    isSelected=true;
    /**/
    rawSource=parent.toString();
    index=rawSource.indexOf('[');
    source=rawSource.substring(0,index);
    /**/
    if      ( source.equals("PlayDeckPanel")        ) {
      pd=mw.getPlayDeck();
      if ( pd.size() == 0 ) {
        JOptionPane.showMessageDialog(mw,"Play Deck is empty.","Input Error",JOptionPane.WARNING_MESSAGE);
        return;
      }
      pdp=mw.getPlayDeckPanel();
      up=pdp.getUpClickableCard();
      down=pdp.getDownClickableCard();
      if      ( up.isSelected()   ) {
        up.setSelected(false);
        source += " up";
      }
      else if ( down.isSelected() ) {
        down.setSelected(false);
        source += " down";
      }
    }
    else if ( source.equals("DestinationDeckPanel") ) {
      ddp=mw.getDestinationDeckPanel();
      cca=ddp.getClickableCards();
      index=-1;
      for ( int i=0; i<4; ++i ) {
        if ( cca[i].isSelected() ) {
          cca[i].setSelected(false);
          index=i;
          break;
        }
      }
      source += ( " " + index );
    }
    /*
     *  from click
     */
    if ( !mp.fromIsSet() ) {
      mp.setFrom(true);
      mp.setFromSource(source);
    }
    /*
     *  to click
     */
    else {
      mp.setFrom(false);
      mp.setToSource(source);
    }
    setSelectedImage(source);
    /**/
    return;
  }
  /**/
  public void mouseEntered ( MouseEvent me ) {
    return;
  }
  /**/
  public void mouseExited ( MouseEvent me ) {
    return;
  }
  /**/
  public void mousePressed ( MouseEvent me ) {
    return;
  }
  /**/
  public void mouseReleased ( MouseEvent me ) {
    return;
  }
  /**/
  private void setSelectedImage ( String s ) {
    /**/
    int sdd;
    CardResources cr;
    ClickableCard up, down, cc;
    ClickableCard [] cca;
    DestinationDeck dd;
    DestinationDeck [] dda;
    DestinationDeckPanel ddp;
    PlayDeck pd;
    PlayDeckPanel pdp;
    String component;
    String [] tokens;
    /**/
    cr=mw.getCardResources();
    /**/
    tokens=s.split(" ");
    component=tokens[1];
    if ( tokens[0].equals("PlayDeckPanel")             ) {
      pd=mw.getPlayDeck();
      pdp=mw.getPlayDeckPanel();
      if      ( component.equals("up")   ) {
        up=pdp.getUpClickableCard();
        if ( pd.getUpDeck().size() == 0 ) up.setImage(cr.getLightImage("empty"));
        else                              up.setImage(cr.getLightImage(pd.getTopCard().getName()));
      }
      else if ( component.equals("down") ) {
        down=pdp.getDownClickableCard();
        if ( pd.canDraw() ) down.setImage(cr.getLightImage("back"));
        else                down.setImage(cr.getLightImage("empty"));
      }
    }
    else if ( tokens[0].equals("DestinationDeckPanel") ) {
      ddp=mw.getDestinationDeckPanel();
      cca=ddp.getClickableCards();
      dda=mw.getDestinationDecks();
      sdd=Integer.parseInt(component);
      dd=dda[sdd];
      cc=cca[sdd];
      /**/
      if ( dd.isEmpty() ) cc.setImage(cr.getLightImage("empty"));
      else                cc.setImage(cr.getLightImage(dd.getLastCard().getName()));
    }
    /**/
    return;
  }
}
