import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.image.BufferedImage;
import javax.swing.JPanel;
/**/
public class ColumnDecksPanel extends JPanel {
  /**/
  private CardStackPanel [] cspa;
  private MainWindow mw;
  /**/
  public ColumnDecksPanel ( MainWindow mw, CardRows crs ) {
    /**/
    super();
    setFocusable(false);
    /**/
    this.mw=mw;
    initStacks(crs);
    init();
  }
  /**/
  public CardStackPanel [] getCardStackPanels () {
    return cspa;
  }
  /**/
  public void newGame ( CardRows crs, CardResources cr ) {
    /**/
    int len;
    BufferedImage [] bia;
    Card c;
    CardRow [] cra;
    /**/
    cra=crs.getCardRows();
    for ( int i=0; i<7; ++i ) {
      len=cra[i].size();
      bia=new BufferedImage [len];
      for ( int j=0; j<len; ++j ) {
        c=cra[i].getCardFromIndex(j);
        if ( j != len-1 ) {
          c.flip();
          bia[j]=cr.getPartialImage("back");
        }
        else {
          bia[j]=cr.getImage(c.getName());
        }
      }
      cspa[i].setSelectedIndex(-1);
      cspa[i].setImages(bia);
    }
    /**/
    return;
  }
  /**/
  private void initStacks ( CardRows crs ) {
    /**/
    int len;
    BufferedImage [] bia;
    Card c;
    CardRow [] cra;
    /**/
    cra=crs.getCardRows();
    /**/
    cspa=new CardStackPanel [7];
    for ( int i=0; i<7; ++i ) {
      len=cra[i].size();
      bia=new BufferedImage [len];
      for ( int j=0; j<len; ++j ) {
        c=cra[i].getCardFromIndex(j);
        if ( j != len-1 ) c.flip();
        bia[j]=c.getImage();
      }
      cspa[i]=new CardStackPanel(mw,this,bia);
    }
    /**/
    return;
  }
  /**/
  private void init () {
    /**/
    GridBagLayout gbl;
    int gridx, gridy, gridwidth, gridheight, anchor, fill, ipadx, ipady;
    Insets insets;
    double weightx, weighty;
    /**/
    gbl=new GridBagLayout();
    setLayout(gbl);
    /**/
    gridy=0; gridwidth=1; gridheight=1; fill=GridBagConstraints.NONE;  ipadx=0;  ipady=0;
    insets=new Insets(2,2,2,2);
    weighty=0.5;
    /**/
    for ( int i=0; i<7; ++i ) {
      gridx=i;
      if      ( i == 0 ) {
        weightx=0.5;
        anchor=GridBagConstraints.NORTHEAST;
      }
      else if ( i == 6 ) {
        weightx=0.5;
        anchor=GridBagConstraints.NORTHWEST;
      }
      else {
        weightx=0.0;
        anchor=GridBagConstraints.NORTH;
      }
      gbl.setConstraints(cspa[i],
        new GridBagConstraints(
          gridx, gridy, gridwidth, gridheight, weightx, weighty,
          anchor, fill, insets, ipadx, ipady
        )
      );
      add(cspa[i]);
    }
    /**/
    return;
  }
}
