public class Deck {
  /**/
  private int position;
  private Card [] ca;
  /**/
  public Deck ( CardResources cr ) {
    init(cr);
  }
  /**/
  public Card deal () {
    return ca[position++];
  }
  /**/
  public Card [] getRemainingDeck () {
    /**/
    int size;
    Card [] rv;
    /**/
    size=52-position;
    rv=new Card [size];
    for ( int i=0; i<size; ++i ) rv[i]=ca[position++];
    /**/
    return rv;
  }
  /**/
  private void init ( CardResources cr ) {
    /**/
    int [] rl;
    Card [] unshuffled;
    String [] names;
    /**/
    names=cr.getCardNames();
    unshuffled=new Card [52];
    for ( int i=0; i<52; ++i ) unshuffled[i]=new Card(names[i],cr);
    /**/
    ca=new Card [52];
    rl=randomList();
    for ( int i=0; i<52; ++i ) ca[i]=unshuffled[rl[i]];
    /**/
    position=0;
  }
  /**/
  private static int [] randomList () {
    /**/
    int ri;
    int [] rv;
    /**/
    rv=new int [52];
    for ( int i=0; i<52; ++i ) rv[i]=52;
    /**/
    for ( int i=0; i<52; ++i ) {
      while ( true ) {
        ri=(int)(52.0*Math.random());
        if ( !contains(ri,rv) ) {
          rv[i]=ri;
          break;
        }
      }
    }
    /**/
    return rv;
  }
  /**/
  private static boolean contains ( int n, int [] list ) {
    /**/
    for ( int i=0; i<52; ++i ) {
      if ( list[i] == n ) return true;
    }
    return false;
  }
}
