import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.image.BufferedImage;
import javax.swing.JLabel;
import javax.swing.JPanel;
/**/
public class DestinationDeckPanel extends JPanel {
  /**/
  private MainWindow mw;
  private ClickableCard [] cca;
  /**/
  public DestinationDeckPanel ( MainWindow mw, CardResources cr ) {
    /**/
    super();
    setFocusable(false);
    /**/
    BufferedImage empty;
    /**/
    empty=cr.getImage("empty");
    cca=new ClickableCard [4];
    for ( int i=0; i<4; ++i ) cca[i]=new ClickableCard(mw,this,empty);
    /**/
    init();
  }
  /**/
  public ClickableCard [] getClickableCards () {
    return cca;
  }
  /**/
  public void newGame ( CardResources cr ) {
    /**/
    BufferedImage bi;
    /**/
    bi=cr.getImage("empty");
    for ( int i=0; i<4; ++i ) {
      cca[i].setSelected(false);
      cca[i].setImage(bi);
    }
    /**/
    return;
  }
  /**/
  private void init () {
    /**/
    GridBagLayout gbl;
    int gridx, gridy, gridwidth, gridheight, anchor, fill, ipadx, ipady;
    Insets insets;
    double weightx, weighty;
    Color [] ca;
    JLabel [] labels;
    String [] text;
    /**/
    gbl=new GridBagLayout();
    setLayout(gbl);
    /**/
    gridy=0;  gridwidth=1;  gridheight=1;  fill=GridBagConstraints.NONE;  ipadx=0;  ipady=0;
    insets=new Insets(2,2,2,2);
    weighty=0.5;
    /**/
    for ( int i=0; i<4; ++i ) {
      gridx=i;
      if      ( i == 0 ) {
        anchor=GridBagConstraints.EAST;
        weightx=0.5;
      }
      else if ( i == 3 ) {
        anchor=GridBagConstraints.WEST;
        weightx=0.5;
      }
      else {
        anchor=GridBagConstraints.CENTER;
        weightx=0.0;
      }
      gbl.setConstraints(cca[i],
        new GridBagConstraints(
          gridx, gridy, gridwidth, gridheight, weightx, weighty,
          anchor, fill, insets, ipadx, ipady
        )
      );
      add(cca[i]);
    }
    /*
     *  labels
     */
    gridy=1;  anchor=GridBagConstraints.NORTH;
    /**/
    labels=new JLabel [4];
    text=new String [] {
      "c" , "d" , "h" , "s"
    };
    ca=new Color [] {
      Color.black, Color.red, Color.red, Color.black
    };
    for ( int i=0; i<4; ++i ) {
      labels[i]=new JLabel(text[i]);
      labels[i].setForeground(ca[i]);
    }
    /**/
    for ( int i=0; i<4; ++i ) {
      gridx=i;
      if      ( i == 0 ) weightx=0.5;
      else if ( i == 3 ) weightx=0.5;
      else               weightx=0.0;
      gbl.setConstraints(labels[i],
        new GridBagConstraints(
          gridx, gridy, gridwidth, gridheight, weightx, weighty,
          anchor, fill, insets, ipadx, ipady
        )
      );
      add(labels[i]);
    }
    /**/
    return;
  }
}
