import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;
/**/
public class HelpDialog extends JDialog implements ActionListener {
  /**/
  private MainWindow mw;
  private JScrollPane jsp;
  private JPanel jp;
  private HelpTextArea hta;
  /**/
  public HelpDialog ( MainWindow mw ) {
    /**/
    super(mw,false);
    /**/
    JButton okB;
    /**/
    this.mw=mw;
    setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    setTitle("Help");
    /**/
    hta=new HelpTextArea(mw);
    jsp=new JScrollPane(
      hta,
      ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
      ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER
    );
    /**/
    okB=new JButton("OK");
    okB.setMnemonic(KeyEvent.VK_O);
    okB.addActionListener(this);
    /**/
    doLayout(okB);
  }
  /**/
  public JScrollPane getScrollPane() {
    return jsp;
  }
  /**/
  public JPanel getPanel() {
    return jp;
  }
  /**/
  public void showHelpDialog() {
    /**/
    Point p;
    /**/
    p=mw.getLocationOnScreen();
    pack();
    setLocation(p.x+50,p.y+50);
    setVisible(true);
    /**/
    new InitScrollBar(this).start();
    /**/
    return;
  }
  /**/
  public void actionPerformed ( ActionEvent ae ) {
    /**/
    setVisible(false);
    dispose();
    /**/
    return;
  } 
  /**/
  private void doLayout ( JButton okB ) {
    /**/
    int gridx, gridy, gridwidth, gridheight, anchor, fill, ipadx, ipady;
    double weightx, weighty;
    GridBagLayout gbl;
    Insets insets;
    /**/
    jp=new JPanel();
    gbl=new GridBagLayout();
    jp.setLayout(gbl);
    /**/
    fill=GridBagConstraints.NONE;  ipadx=2;  ipady=2;
    /*
     *  jsp
     */
    gridx=0;  gridy=0;  gridwidth=1;  gridheight=1;
    anchor=GridBagConstraints.SOUTH;
    weightx=1.0;  weighty=0.5;
    insets=new Insets(20,20,0,20);
    gbl.setConstraints(jsp,
      new GridBagConstraints(
        gridx, gridy, gridwidth, gridheight, weightx, weighty,
        anchor, fill, insets, ipadx, ipady
      )
    );
    jp.add(jsp);
    /*
     *  okB
     */
    gridx=0;  gridy=1;  gridwidth=1;  gridheight=1;
    anchor=GridBagConstraints.NORTH;
    weightx=1.0;  weighty=0.5;
    insets=new Insets(20,20,20,20);
    gbl.setConstraints(okB,
      new GridBagConstraints(
        gridx, gridy, gridwidth, gridheight, weightx, weighty,
        anchor, fill, insets, ipadx, ipady
      )
    );
    jp.add(okB);
    /**/
    getContentPane().add(jp);
    /**/
    return;
  }
}
