import java.awt.Dimension;
import java.awt.Font;
import java.awt.Rectangle;
import java.util.ArrayList;
import javax.swing.JTextArea;
import javax.swing.Scrollable;
/**/
public class HelpTextArea extends JTextArea implements Scrollable {
  /**/
  private static final int VIEWPORT_LINES = 25;
  /**/
  private int unit, block;
  private boolean trackViewportHeight, trackViewportWidth;
  private Dimension psvs;
  /**/
  public HelpTextArea ( MainWindow mw ) {
    /**/
    super();
    /**/
    int noLines, maxLen, len, pw, ph;
    ArrayList<String> helpFile;
    Dimension ps;
    Font font;
    String contentString;
    /**/
    setFocusable(false);
    setEditable(false);
    /**/
    font=new Font(Font.MONOSPACED,Font.PLAIN,12);
    setFont(font);
    /**/
    helpFile=mw.getHelpFile();
    noLines=helpFile.size();
    setRows(noLines);
    /**/
    maxLen=-1;
    for ( int i=0; i<noLines; ++i ) {
      len=helpFile.get(i).length();
      if ( len > maxLen ) maxLen=len;
    }
    setColumns(maxLen);
    /**/
    contentString="";
    for ( int i=0; i<noLines; ++i ) {
      if ( i == noLines-1 ) contentString += helpFile.get(i);
      else                  contentString += ( helpFile.get(i) + System.lineSeparator() );
    }
    setText(contentString);
    /**/
    ps=getPreferredSize();
    /**/
    trackViewportWidth=true;
    trackViewportHeight=false;
    pw=ps.width;
    ph=(int)((double)ps.height*(double)VIEWPORT_LINES/(double)noLines+0.5);
    psvs=new Dimension(pw,ph);
    unit=(int)((double)ps.height/(double)noLines+0.5);
    block=3*unit;
  }
  /**/
  public Dimension getPreferredScrollableViewportSize () {
    return psvs;
  }
  /**/
  public int getScrollableBlockIncrement( Rectangle visibleRect, int orientation, int direction ) {
    return block;
  }
  /**/
  public int getScrollableUnitIncrement( Rectangle visibleRect, int orientation, int direction ) {
    return unit;
  }
  /**/
  public boolean getScrollableTracksViewportHeight () {
    return trackViewportHeight;
  }
  /**/
  public boolean getScrollableTracksViewportWidth () {
    return trackViewportWidth;
  }
}
