import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JTextArea;
/**/
public class InfoDialog extends JDialog implements ActionListener {
  /**/
  private MainWindow mw;
  /**/
  public InfoDialog ( MainWindow mw, String title, String [] text, boolean isModal ) {
    /**/
    super(mw,title,isModal);
    /**/
    Font f;
    JButton dismissButton;
    JPanel dialogPanel;
    JTextArea jta;
    /**/
    this.mw=mw;
    /**/
    f=new Font("Monospaced",Font.PLAIN,12);
    jta=makeContentPanel(f,text);
    /**/
    dismissButton=new JButton("Dismiss");
    dismissButton.setMnemonic(KeyEvent.VK_D);
    dismissButton.addActionListener(this);
    /**/
    dialogPanel=init(jta,dismissButton);
    getContentPane().add(dialogPanel);
  }
  /**/
  public void popUp () {
    /**/
    Point p;
    /**/
    p=mw.getLocationOnScreen();
    setLocation(p.x+50,p.y+50);
    pack();
    setVisible(true);
  }
  /**/
  public void actionPerformed ( ActionEvent ae ) {
    /**/
    setVisible(false);
    dispose();
    /**/
    return;
  }
  /**/
  private JTextArea makeContentPanel ( Font f, String [] text ) {
    /**/
    int rows, cols;
    String info, nl;
    JTextArea rv;
    /**/
    rows=text.length;
    cols=text[0].length();
    rv=new JTextArea(rows,cols);
    /**/
    rv.setFont(f);
    rv.setFocusable(false);
    rv.setEditable(false);
    /**/
    nl=System.lineSeparator();
    info="";
    for ( int i=0; i<rows; ++i ) {
      info += text[i];
      if ( i != rows-1 ) info += nl;
    }
    rv.setText(info);
    /**/
    return rv;
  }
  /**/
  private JPanel init ( JTextArea jta, JButton dismissButton ) {
    /**/
    JPanel rv;
    /**/
    rv=new JPanel();
    /**/
    GridBagLayout gbl;
    int gridx, gridy, gridwidth, gridheight, anchor, fill, ipadx, ipady;
    Insets insets;
    double weightx, weighty;
    /**/
    gbl=new GridBagLayout();
    rv.setLayout(gbl);
    /*
     *  jta
     */
    gridx=0;  gridy=0;  gridwidth=1;  gridheight=1;
    weightx=1.0;  weighty=0.5;
    anchor=GridBagConstraints.SOUTH;
    fill=GridBagConstraints.NONE;
    insets=new Insets(15,15,15,15);
    ipadx=0;  ipady=0;
    /**/
    gbl.setConstraints(jta,
      new GridBagConstraints(
        gridx, gridy, gridwidth, gridheight, weightx, weighty,
        anchor, fill, insets, ipadx, ipady
      )
    );
    rv.add(jta);
    /*
     *  dismissButton
     */
    gridx=0;  gridy=1;  gridwidth=1;  gridheight=1;
    weightx=1.0;  weighty=0.5;
    anchor=GridBagConstraints.NORTH;
    fill=GridBagConstraints.NONE;
    insets=new Insets(15,15,15,15);
    ipadx=0;  ipady=0;
    /**/
    gbl.setConstraints(dismissButton,
      new GridBagConstraints(
        gridx, gridy, gridwidth, gridheight, weightx, weighty,
        anchor, fill, insets, ipadx, ipady
      )
    );
    rv.add(dismissButton);
    /**/
    return rv;
  }
}
