import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JMenuItem;
/**/
public class MenuCallBacks implements ActionListener {
  /**/
  private MainWindow mw;
  private JMenuItem help, about, newg, exit;
  /**/
  public MenuCallBacks ( MainWindow mw ) {
    /**/
    MainMenu mm;
    /**/
    this.mw=mw;
    mm=mw.getMainMenu();
    /**/
    help=mm.getHelpItem();
    about=mm.getAboutItem();
    newg=mm.getNewGameItem();
    exit=mm.getExitItem();
    /**/
    help.addActionListener(this);
    about.addActionListener(this);
    newg.addActionListener(this);
    exit.addActionListener(this);
  }
  /**/
  public void actionPerformed ( ActionEvent ae ) {
    /**/
    JMenuItem source;
    /**/
    source=(JMenuItem)ae.getSource();
    if      ( source == help  ) doHelp();
    else if ( source == about ) doAbout();
    else if ( source == newg  ) doNewGame();
    else if ( source == exit  ) doExit();
    /**/
    return;
  }
  /**/
  private void doHelp () {
    /**/
    HelpDialog hd;
    /**/
    hd=new HelpDialog(mw);
    hd.showHelpDialog();
    /**/
    return;
  }
  /**/
  private void doAbout () {
    /**/
    InfoDialog id;
    String [] info;
    /**/
    info=new String [] {
      "                                               " ,
      "              S o l i t a i r e                " ,
      "                                               " ,
      "                 written by                    " ,
      "                                               " ,
      "   Stephen V. Harren (http://www.harren.us)    " ,
      "                                               " ,
      "     This program, and its source code, is     " ,
      " distributed \"as-is\". No liability is assumed. " ,
      "                                               "
    };
    id=new InfoDialog(mw,"About",info,false);
    id.popUp();
    /**/
    return;
  }
  /**/
  private void doNewGame () {
    mw.newGame();
  }
  /**/
  private void doExit () {
    System.exit(0);
  }
}
