import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.image.BufferedImage;
import javax.swing.JPanel;
/**/
public class PlayDeckPanel extends JPanel {
  /**/
  private ClickableCard up, down;
  /**/
  public PlayDeckPanel ( MainWindow mw, CardResources cr ) {
    /**/
    super();
    setFocusable(false);
    /**/
    BufferedImage upI, downI;
    /**/
    upI=cr.getImage("empty");
    downI=cr.getImage("back");
    /**/
    up=new ClickableCard(mw,this,upI);
    down=new ClickableCard(mw,this,downI);
    /**/
    init();
  }
  /**/
  public ClickableCard getUpClickableCard () {
    return up;
  }
  /**/
  public ClickableCard getDownClickableCard () {
    return down;
  }
  /**/
  public void newGame ( CardResources cr ) {
    /**/
    BufferedImage upI, downI;
    /**/
    upI=cr.getImage("empty");
    downI=cr.getImage("back");
    /**/
    up.setSelected(false);
    down.setSelected(false);
    /**/
    up.setImage(upI);
    down.setImage(downI);
    /**/
    return;
  }
  /**/
  private void init () {
    /**/
    GridBagLayout gbl;
    int gridx, gridy, gridwidth, gridheight, anchor, fill, ipadx, ipady;
    Insets insets;
    double weightx, weighty;
    /**/
    gbl=new GridBagLayout();
    setLayout(gbl);
    /**/
    gridy=0;                       gridwidth=1;  gridheight=1;
    fill=GridBagConstraints.NONE;  ipadx=0;      ipady=0;
    weightx=0.5;                   weighty=1.0;
    insets=new Insets(2,2,2,2);
    /*
     *  up
     */
    gridx=0;  anchor=GridBagConstraints.EAST;
    gbl.setConstraints(up,
      new GridBagConstraints(
        gridx, gridy, gridwidth, gridheight, weightx, weighty,
        anchor, fill, insets, ipadx, ipady
      )
    );
    add(up);
    /*
     *  down
     */
    gridx=1;  anchor=GridBagConstraints.WEST;
    gbl.setConstraints(down,
      new GridBagConstraints(
        gridx, gridy, gridwidth, gridheight, weightx, weighty,
        anchor, fill, insets, ipadx, ipady
      )
    );
    add(down);
    /**/
    return;
  }
}
